#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define ALLELE     27 // Η`q
#define L          17 // `q
#define N        1000 // WcTCY
#define P        0.03 // ˑRψٗ
#define BEST_N     30 // G[g헪ŎɎc̐
#define GEN      1000 // wK

struct Indivisual {
  int    gene[L]; // `q^
  double fitness; // KxB̖̏ꍇint^
};

Indivisual indiv[N]; // ̏Wc

// ̕
char* ans = "genetic algorithm";

// 0ȏ1̈l𔭐֐
double random() {
  return (double)(rand()/(RAND_MAX + 1.0));
}

// ȉ̎O̊֐͏ȗ
void mutation(Indivisual* indiv);
int roulette_selection();
void uniform_crossover(Indivisual* child1, Indivisual* child2, 
                       Indivisual* parent1, Indivisual* parent2);

// nԖڂ̌̂\֐
void show(int n) {
  int i;
  for (i = 0; i < L; i++) {
    if (indiv[n].gene[i] == 0) {
      printf(" ");
    } else {
      // uaṽAXL[R[h97Ȃ̂+96
      printf("%c", (indiv[n].gene[i] + 96));
    }
  }
}

// Wc𐶐֐
void init() {
  int i, j;
  for (i = 0; i < N; i++) {
    // `qׂĂ_Ɍ߂
    for (j = 0; j < L; j++) {
      indiv[i].gene[j] = (int)(random() * ALLELE);
    }
  }
}

// nԖڂ̌̂̓KxvZ֐
// ̖̏ꍇ́C߂lint^
double compfitness(int n) {
  int i;
  int fit = 0;
  for (i = 0; i < L; i++) {
    if (((indiv[n].gene[i] + 96) == ans[i]) ||
        (ans[i] == ' ' && indiv[n].gene[i] == 0)) {
      fit++;
    }
  }
  return fit;
}

// KxvZ֐
void compute_fitness() {
  int i;
  for (i = 0; i < N; i++) {
    indiv[i].fitness = compfitness(i);
  }
}

// ̂~Ƀ\[g֐iou\[g̗j
void sort() {
  int i, j;
  for (i = 0; i < N - 1; i++) {
    for (j = N - 1; j > i; j--) {
      if (indiv[j - 1].fitness < indiv[j].fitness) {
        Indivisual tmp = indiv[j - 1];
        indiv[j - 1] = indiv[j];
        indiv[j] = tmp;
      }
    }
  }
}

void main() {
  int i, j;
  int i1, i2;
  init();// 

  for (i = 0; i < GEN; i++) {
    printf("%d ", i);
    compute_fitness(); // Kx̌vZ
    sort();            // Kx̑傫ɕׂ
    show(0);           // ł悢̂\
    printf(" error=%f\n", L - indiv[0].fitness);
    // I
    if (indiv[0].fitness == L) return;

    // Wc
    Indivisual next_indiv[N];

    // G[g헪
    for (j = 0; j < BEST_N; j++) {
      next_indiv[j] = indiv[j];
    }
    // c̓[bgőIE
    for (j = BEST_N; j < N; j++) {
      // I
      i1 = roulette_selection();
      while (i1 == (i2 = roulette_selection()));

      // Bq̂̂CЕgpȂꍇ
      Indivisual dummy;//_~[
      uniform_crossover(&next_indiv[j], &dummy, &indiv[i1], &indiv[i2]);
    }
    // ˑRψفBŗǌ̈ȊO͓ˑRψق̑ΏۂƂꍇ
    for (j = 1; j < N; j++) {
      mutation(&next_indiv[j]);
    }
    // newindijindijɃRs[
    for (j = 0; j < N; j++) {
      indiv[j] = next_indiv[j];
    }
  }
}

//p.86
void mutation(Indivisual* indiv) {
	int pos; // ˑRψق`q
	int g;   // ˑRψٌ̈`q
	if (random() < P) { // random() ͋[0,1) ̗֐
		pos = (int)(random() * L); // L ͈`q
		// ALLELE ͑Η`q̐
		while (indiv->gene[pos] == (g = (int)(random() * ALLELE)));
		indiv->gene[pos] = g;
	}
}

//p.85
// child1, child2 ͎q́Cparent1, parent2 ͑Iꂽe
void uniform_crossover(Indivisual* child1, Indivisual* child2,
  Indivisual* parent1, Indivisual* parent2) {
  int i;
  for (i = 0; i < L; i++) { // L ͈`q
    if (random() < 0.5) { // random() ͋[0,1) ̗֐
      child1->gene[i] = parent1->gene[i];
      child2->gene[i] = parent2->gene[i];
    } else {
      child1->gene[i] = parent2->gene[i];
      child2->gene[i] = parent1->gene[i];
    }
  }
}

//p.82
int roulette_selection() {
  int k, r;
  double t = 0, tf = 0; // Kx̑aۑϐ
  for (k = 0; k < N; k++) { // N ͏WcTCY
    t += indiv[k].fitness; // k ̓KxZ
  }
  r = (int)(random() * t); // random() ͋[0,1) ̗֐
  for (k = 0; k < N; k++) {
    tf += indiv[k].fitness;
    if (r < tf) {
      return k; // k IďI
    }
  }
}